package com.danitheskunk.skunkworks;

import com.danitheskunk.skunkworks.gfx.threedee.IRenderContext3D;
import com.danitheskunk.skunkworks.gfx.threedee.Mesh;
import org.lwjgl.assimp.AIMesh;
import org.lwjgl.assimp.Assimp;

public class Test3D extends BaseGame {
	private Mesh[] meshes;
	public Test3D() {
		super(new Vec2i(1920, 1080), "Skunkworks 3d test");
		System.out.printf("assimp version: %d.%d.%d\n",
			Assimp.aiGetVersionMajor(),
			Assimp.aiGetVersionMinor(),
			Assimp.aiGetVersionPatch()
		);
		var path = "C:\\stream\\models\\Dani.glb";
		var bytes = engine.loadBytes(path);
		var flags = Assimp.aiProcess_Triangulate;
		flags |= Assimp.aiProcess_OptimizeGraph;
		flags |= Assimp.aiProcess_PreTransformVertices;
		//flags |= Assimp.aiProcess_OptimizeMeshes;
		//flags |= Assimp.aiProcess_Debone;
		var ai = Assimp.aiImportFile(path, flags);
		if(ai == null) {
			throw new RuntimeException("couldn't load model because: " +
				Assimp.aiGetErrorString());
		}
		var numMeshes = ai.mNumMeshes();
		var meshespb = ai.mMeshes();
		meshes = new Mesh[numMeshes];
		int faces = 0;
		for(int i = 0; i < numMeshes; ++i) {
			var aiMesh = AIMesh.create(meshespb.get(i));
			var mesh = Mesh.fromAIMesh(aiMesh);
			meshes[i] = mesh;
			System.out.println(aiMesh.mNumFaces());
			faces += aiMesh.mNumFaces();
		}

		System.out.printf("numMeshes: %d, faces: %d\n", numMeshes, faces);
	}

	static public void main(String[] args) {
		new Test3D().run();
	}

	@Override
	protected void render3D(IRenderContext3D rc) {
		for(int i = 0; i < meshes.length; ++i) {
			rc.renderMesh(meshes[i]);
		}
		/*
		rc.renderTriangle(new Vec3f(-10, -10, 1),
			new Vec3f(10, -10, 1),
			new Vec3f(10, 10, 1)
		);
		 */

	}
}
